////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                            //
//                                       WATTO STUDIOS                                        //
//                             Java Code, Programs, and Software                              //
//                                    http://www.watto.org                                    //
//                                                                                            //
//                           Copyright (C) 2004-2010  WATTO Studios                           //
//                                                                                            //
// This program is free software; you can redistribute it and/or modify it under the terms of //
// the GNU General Public License published by the Free Software Foundation; either version 2 //
// of the License, or (at your option) any later versions. This program is distributed in the //
// hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranties //
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License //
// at http://www.gnu.org for more details. For updates and information about this program, go //
// to the WATTO Studios website at http://www.watto.org or email watto@watto.org . Thanks! :) //
//                                                                                            //
////////////////////////////////////////////////////////////////////////////////////////////////

package org.watto.program.android.chumsgroup;

import android.app.Activity;
import android.graphics.Color;
import android.widget.LinearLayout;
import android.widget.TextView;

/***********************************************************************************************

***********************************************************************************************/
public class MessageEntry {

  String name = "";
  String chumber = "";
  String mood = "";

  String color = "";

  String message = "";

  String timestamp = "";


  /***********************************************************************************************

  ***********************************************************************************************/
  public MessageEntry(){}

  
  public LinearLayout generateLayout(Activity activity){
    // Create a new post
    LinearLayout layout = (LinearLayout)activity.getLayoutInflater().inflate(R.layout.message_entry,null);
    
    // Determine the color number
    int colorNumber = Color.parseColor(color);
    int textColor = Color.BLACK;
    
    // Determine the color of the text
    if ((Color.red(colorNumber) < 100) && (Color.green(colorNumber) < 100) && (Color.blue(colorNumber) < 100)){
      textColor = Color.WHITE;
    }
    
    
    // Add the content to the post
    TextView nameField = (TextView)layout.getChildAt(0);
    nameField.setText(name + " (Chumber " + chumber + ")");
    nameField.setBackgroundColor(colorNumber);
    nameField.setTextColor(textColor);
    
    TextView moodField = (TextView)layout.getChildAt(1);
    moodField.setText(mood);
    moodField.setBackgroundColor(colorNumber);
    moodField.setTextColor(textColor);
    
    TextView messageField = (TextView)layout.getChildAt(2);
    messageField.setText(message);
    
    TextView timeField = (TextView)layout.getChildAt(3);
    timeField.setText(timestamp);
    
    return layout;
  }

  public String getChumber(){
    return chumber;
  }


  public String getColor(){
    return color;
  }


  public String getMessage(){
    return message;
  }


  public String getMood(){
    return mood;
  }


  public String getName(){
    return name;
  }


  public String getTimestamp(){
    return timestamp;
  }


  public void setChumber(String chumber){
    this.chumber = chumber;
  }


  public void setColor(String color){
    this.color = color;
  }


  public void setMessage(String message){
    this.message = message;
  }


  public void setMood(String mood){
    this.mood = mood;
  }


  public void setName(String name){
    this.name = name;
  }


  public void setTimestamp(String timestamp){
    this.timestamp = timestamp;
  }

}