////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                            //
//                                       WATTO STUDIOS                                        //
//                             Java Code, Programs, and Software                              //
//                                    http://www.watto.org                                    //
//                                                                                            //
//                           Copyright (C) 2004-2010  WATTO Studios                           //
//                                                                                            //
// This program is free software; you can redistribute it and/or modify it under the terms of //
// the GNU General Public License published by the Free Software Foundation; either version 2 //
// of the License, or (at your option) any later versions. This program is distributed in the //
// hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranties //
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License //
// at http://www.gnu.org for more details. For updates and information about this program, go //
// to the WATTO Studios website at http://www.watto.org or email watto@watto.org . Thanks! :) //
//                                                                                            //
////////////////////////////////////////////////////////////////////////////////////////////////

package org.watto.program.android.chumsgroup;

import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;
import org.watto.android.Settings;
import org.watto.android.WSAboutScreen;
import org.watto.android.WSSettingsChanger;
import org.watto.android.component.WSAndroidPopup;
import org.watto.android.event.WSViewClickableInterface;
import org.watto.android.event.listener.WSViewClickableListener;
import android.app.Activity;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.text.Html;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ScrollView;


/***********************************************************************************************
Calculates the Weight Points value for a food product
***********************************************************************************************/
public class PostsWindow extends Activity implements WSViewClickableInterface {

  /***********************************************************************************************
  Performs an action when a single-click event is triggered on a <code>View</code>
  @param source the <code>View</code> that triggered the event
  @return <b>true</b> if the event was handled by this class<br />
          <b>false</b> if the event wasn't handled by this class, and thus should be passed on to
          the parent class for handling.
  ***********************************************************************************************/
  public boolean onClick(View source){
    int id = source.getId();
    if (id == R.id.button_post_message) {
      callWritePostWindowActivity();
    }
    else {
      return false;
    }
    return true;
  }


  /***********************************************************************************************
  Creates the <code>Activity</code> from the XML file
  @param savedInstanceState the saved state of the <code>Activity</code>
  ***********************************************************************************************/
  public void onCreate(Bundle savedInstanceState){
    super.onCreate(savedInstanceState);


    

    // Creates the view from the XML file
    setContentView(R.layout.posts_window);
 
    // Set the View Click Listeners
    WSViewClickableListener viewClickableListener = new WSViewClickableListener(this);
    ((Button)findViewById(R.id.button_post_message)).setOnClickListener(viewClickableListener);

    
  // LOOK AT onResume() for the losding of the messages
    
        
  }
  
  
  final int DIALOG_LOADING = 1;
  
  /***********************************************************************************************
  Overwritten to handle change of screen orientation while the dialog is showing
  ***********************************************************************************************/
  protected Dialog onCreateDialog(int id) {
    if(id == DIALOG_LOADING){
    ProgressDialog loadingDialog = new ProgressDialog(this);
    loadingDialog.setMessage("Reading Chumberlog...");
    loadingDialog.setIndeterminate(true);
    loadingDialog.setCancelable(true);
    return loadingDialog;
    }

    return super.onCreateDialog(id);
    }
  
  /***********************************************************************************************
  Overwritten to close the dialog when clicking the 'back' button and returning to this activity
  ***********************************************************************************************/
  protected void onSaveInstanceState(Bundle outState) {
    try {
    dismissDialog(DIALOG_LOADING);
    } catch (Exception e) {
    //ignore error
    }
    super.onSaveInstanceState(outState);
    }
  
  
  /***********************************************************************************************

  ***********************************************************************************************/
  /*public void runLoadMessagesThread(){
    // "Loading" popup
    showDialog(DIALOG_LOADING);


    // call loadMessages() in a Thread
    new Thread(new Runnable(){
      public void run(){
      loadMessages();
      dismissDialog(DIALOG_LOADING);
      
      }
      }).start();
  }*/
    
    
    /***********************************************************************************************

     ***********************************************************************************************/
     /*public void loadMessages(){
       
       // Get the posts list
       LinearLayout postsList = (LinearLayout)findViewById(R.id.posts_list);
    
    try {

      // 1. Call a GET to http://chumsgroup.com
    String queryUrl = "http://chumsgroup.com";
    HttpGet request = new HttpGet(queryUrl);

    DefaultHttpClient client = SharedHttpClient.getClient();
    HttpResponse response = client.execute(request);

    // 2. Extract the messages from the HTML response
    if (response.getStatusLine().getStatusCode() == HttpStatus.SC_OK) {
      String responseMessage = EntityUtils.toString(response.getEntity());

      String[] lines = responseMessage.split("\n");
      int lineCount = lines.length;
      
      MessageEntry entry = null;
      
      String searchStatusUpdate = "status_update";
      String searchUserInfo = "class=\"user info\"";
      String searchName = "class=\"name\"";
      String searchChumber = "class=\"chumber\"";
      String searchMood = "class=\"mood\"";
      String searchContent = "class=\"content\"";
      String searchPostedAt = "class=\"posted_at\"";
      
      boolean inMessage = false;
      
      for (int i=0;i<lineCount;i++){
        String line = lines[i];
        int lineLength = line.length();
        
        if (inMessage){
          // MESSAGE (OVER MULTIPLE LINES)
          int endPos = line.indexOf("</div>");
          if (endPos > 0){
            line = line.substring(0,endPos);
            inMessage = false;
          }
          line.trim();
          entry.setMessage(entry.getMessage() + " " + line);
        }
        else if (line.contains(searchStatusUpdate)){
          // NEW ENTRY
          if (entry != null){
            postsList.addView(entry.generateLayout(this));
          }
          entry = new MessageEntry();
        }
        else if (line.contains(searchUserInfo)){
          // COLOR
          int hashPos = line.indexOf("#");
          if (hashPos > 0 && hashPos+7 < lineLength){
            entry.setColor(line.substring(hashPos,hashPos+7));
          }
        }
        else if (line.contains(searchName)){
          // NAME
          int startPos = line.indexOf(">");
          int endPos = line.indexOf("</span>");
          if (startPos > 0 && endPos > 0){
            entry.setName(line.substring(startPos+1,endPos));
          }
        }
        else if (line.contains(searchChumber)){
          // CHUMBER
          int startPos = line.indexOf("Chumber:");
          int endPos = line.indexOf("</span>");
          if (startPos > 0 && endPos > 0){
            entry.setChumber(line.substring(startPos+8,endPos));
          }
        }
        else if (line.contains(searchMood)){
          // MOOD
          int startPos = line.indexOf(">");
          int endPos = line.indexOf("</span>");
          if (startPos > 0 && endPos > 0){
            entry.setMood(line.substring(startPos+1,endPos));
          }
        }
        else if (line.contains(searchContent)){
          // MESSAGE
          int startPos = line.indexOf(">");
          int endPos = line.indexOf("</div>");
          if (startPos > 0 && endPos > 0){
            entry.setMessage(line.substring(startPos+1,endPos));
          }
          else if (startPos > 0){
            entry.setMessage(line.substring(startPos+1));
            inMessage = true;
          }
        }
        else if (line.contains(searchPostedAt)){
          // TIMESTAMP
          int startPos = line.indexOf(">");
          int endPos = line.indexOf("</span>");
          if (startPos > 0 && endPos > 0){
            entry.setTimestamp(line.substring(startPos+1,endPos));
          }
        }
        
      }
      
      if (entry != null){
        postsList.addView(entry.generateLayout(this));
      }
      
      
      /*
      postsList.post(new Runnable() {
        public void run() {
          postsList.requestLayout();
          postsList.refreshDrawableState();
        }
      });
      //postsList.refreshDrawableState();//.postInvalidate();
       
       


    }
    }
    catch (Throwable t){
    }
  


  }*/
     
     
     /***********************************************************************************************

      ***********************************************************************************************/
      public MessageEntry[] loadMessagesArray(){
        
        MessageEntry[] entries = new MessageEntry[80];
        int entryCount = 0;
        
     try {

       // 1. Call a GET to http://chumsgroup.com
     String queryUrl = "http://chumsgroup.com";
     HttpGet request = new HttpGet(queryUrl);
     request.setHeader("Accept","text/html"); // force html response
     request.setHeader("Accept-Encoding","identity"); // force no-compression response (for 3G compat)

     DefaultHttpClient client = SharedHttpClient.getClient();
     HttpResponse response = client.execute(request);

     // 2. Extract the messages from the HTML response
     if (response.getStatusLine().getStatusCode() == HttpStatus.SC_OK) {
       String responseMessage = EntityUtils.toString(response.getEntity());

       String[] lines = responseMessage.split("\n");
       int lineCount = lines.length;
       
       MessageEntry entry = null;
       
       String searchStatusUpdate = "status_update";
       String searchUserInfo = "class=\"user info\"";
       String searchName = "class=\"name\"";
       String searchChumber = "class=\"chumber\"";
       String searchMood = "class=\"mood\"";
       String searchContent = "class=\"content\"";
       String searchPostedAt = "class=\"posted_at\"";
       String searchUserId = "name=\"message[user_id]\"";
       String searchFlagId = "name=\"message[flag_id]\"";
       
       boolean inMessage = false;
       
       for (int i=0;i<lineCount;i++){
         String line = lines[i];
         int lineLength = line.length();
         
         if (inMessage){
           // MESSAGE (OVER MULTIPLE LINES)
           int endPos = line.indexOf("</div>");
           if (endPos > 0){
             line = line.substring(0,endPos);
             inMessage = false;
           }
           line.trim();
           //line = StringEscapeUtils.unescapeHtml(line); // convert HTML characters to normal characters
           line = Html.fromHtml(line).toString();
           entry.setMessage(entry.getMessage() + " " + line);
         }
         else if (line.contains(searchStatusUpdate)){
           // NEW ENTRY
           if (entry != null){
             if (entryCount >= entries.length){ // make the array larger
               int oldLength = entries.length;
               MessageEntry[] temp = entries;
               entries = new MessageEntry[oldLength+10]; // +10 <-- NOTE THIS
               System.arraycopy(temp,0,entries,0,oldLength);
             }
             entries[entryCount] = entry;
             entryCount++;
           }
           entry = new MessageEntry();
         }
         else if (line.contains(searchUserInfo)){
           // COLOR
           int hashPos = line.indexOf("#");
           if (hashPos > 0 && hashPos+7 < lineLength){
             entry.setColor(line.substring(hashPos,hashPos+7));
           }
         }
         else if (line.contains(searchName)){
           // NAME
           int startPos = line.indexOf(">");
           int endPos = line.indexOf("</span>");
           if (startPos > 0 && endPos > 0){
             entry.setName(line.substring(startPos+1,endPos));
           }
         }
         else if (line.contains(searchChumber)){
           // CHUMBER
           int startPos = line.indexOf("Chumber:");
           int endPos = line.indexOf("</span>");
           if (startPos > 0 && endPos > 0){
             entry.setChumber(line.substring(startPos+8,endPos));
           }
         }
         else if (line.contains(searchMood)){
           // MOOD
           int startPos = line.indexOf(">");
           int endPos = line.indexOf("</span>");
           if (startPos > 0 && endPos > 0){
             entry.setMood(line.substring(startPos+1,endPos));
           }
         }
         else if (line.contains(searchContent)){
           // MESSAGE
           int startPos = line.indexOf(">");
           int endPos = line.indexOf("</div>");
           if (startPos > 0 && endPos > 0){
             //entry.setMessage(StringEscapeUtils.unescapeHtml(line.substring(startPos+1,endPos))); // convert HTML characters to normal characters
             entry.setMessage(Html.fromHtml(line.substring(startPos+1,endPos)).toString());
             //entry.setMessage(line.substring(startPos+1,endPos));
           }
           else if (startPos > 0){
             //entry.setMessage(StringEscapeUtils.unescapeHtml(line.substring(startPos+1))); // convert HTML characters to normal characters
             entry.setMessage(Html.fromHtml(line.substring(startPos+1)).toString());
             //entry.setMessage(line.substring(startPos+1));
             inMessage = true;
           }
         }
         else if (line.contains(searchPostedAt)){
           // TIMESTAMP
           int startPos = line.indexOf(">");
           int endPos = line.indexOf("</span>");
           if (startPos > 0 && endPos > 0){
             entry.setTimestamp(line.substring(startPos+1,endPos));
           }
         }
         else if (line.contains(searchUserId)){
           // USER ID
           int startPos = line.indexOf("value=\"");
           int endPos = line.indexOf("\" />");
           if (startPos > 0 && endPos > 0){
             SharedHttpClient.setUserId(line.substring(startPos+7,endPos));
           }
         }
         else if (line.contains(searchFlagId)){
           // FLAG ID
           int startPos = line.indexOf("value=\"");
           int endPos = line.indexOf("\" />");
           if (startPos > 0 && endPos > 0){
             try {
               line = line.substring(startPos+7,endPos);
               int flagNumber = Integer.parseInt(line);
               if (SharedHttpClient.getFlag() <= 0){ // only populate from HTML the first time loading
                 SharedHttpClient.setFlag(flagNumber);
               }
             }
             catch (Throwable t){
             }
           }
         }
         
       }
       
       if (entry != null){
         if (entryCount >= entries.length){ // make the array larger
           int oldLength = entries.length;
           MessageEntry[] temp = entries;
           entries = new MessageEntry[oldLength+1]; // +1 <-- NOTE THIS - only need to add 1 here - last entry
           System.arraycopy(temp,0,entries,0,oldLength);
         }
         entries[entryCount] = entry;
         entryCount++;
       }
       
       
       return entries;


     }
     else {
       this.runOnUiThread(new Runnable(){
         public void run(){
           WSAndroidPopup.showError(getThisActivity(),R.string.error_refresh_failure);
         }
         });
         return new MessageEntry[0];
       }
       
     }
     catch (Throwable t){
     }
   
    return new MessageEntry[0];

   }


      /***********************************************************************************************
      Creates the <code>Menu</code> from the XML file when the Options button is pressed
      @param menu the <code>Menu</code> <code>View</code> to populate with menu items
      @return <b>true</b> to display the menu, <br />
              <b>false</b> to keep the menu hidden.
      ***********************************************************************************************/
      public boolean onCreateOptionsMenu(Menu menu){
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.posts_window,menu);
        return true;
      }


  /***********************************************************************************************
  Performs an action when a <code>MenuItem</code> is selected in the Options menu
  @param item the <code>MenuItem</code> that was selected
  @return <b>true</b> if the event was handled by this class<br />
          <b>false</b> if the event wasn't handled by this class, and thus should be passed on to
          the parent class for handling.
  ***********************************************************************************************/
      public boolean onOptionsItemSelected(MenuItem item){
        int id = item.getItemId();
        if (id == R.id.menu_posts_window_about) {
          showAbout();
        }
        else if (id == R.id.menu_posts_window_settings) {
          showSettings();
        }
        else if (id == R.id.menu_posts_window_post_message) {
          callWritePostWindowActivity();
        }
        else if (id == R.id.menu_posts_window_refresh) {
          new LoadMessagesTask().execute();
        }
        else {
        return false;
        }
        return true;
      }


  /***********************************************************************************************
  Hides the screen fields whenever the <code>Activity</code> is brought to the foreground
  ***********************************************************************************************/
  public void onResume(){
    super.onResume();
    
    // Load the messages on first run, and when returning here from posting a message
    // runLoadMessagesThread();
    new LoadMessagesTask().execute();

  }
  
  
  /***********************************************************************************************

  ***********************************************************************************************/
  public void callWritePostWindowActivity(){
    Intent writePostActivity = new Intent(getBaseContext(),WritePostWindow.class);
    startActivity(writePostActivity);
  }
  
  
  /***********************************************************************************************

   ***********************************************************************************************/
  public void addPostEntry(MessageEntry entry){
    //postsList.addView(entry.generateLayout(this));
  }
  
  
  /***********************************************************************************************

   ***********************************************************************************************/
  public Activity getThisActivity(){
    return this;
  }

  


  /***********************************************************************************************
  A background Thread for loading the Flickr Username into the username field on the GUI
   ***********************************************************************************************/
  protected class LoadMessagesTask extends AsyncTask<Object,Object,Object> {

    MessageEntry[] entries = null;
    
    /***********************************************************************************************

     ***********************************************************************************************/
    protected void onPreExecute(){
      showDialog(DIALOG_LOADING);
    }

    /***********************************************************************************************
    Runs the task in the background
    @param arguments the arguments passed to the background task
    @return the result of the background operation
     ***********************************************************************************************/
    protected Object doInBackground(Object ... arguments){
      entries = loadMessagesArray();
      return true;
    }


    /***********************************************************************************************
    Updates the GUI after the task has finished running
    @param result the result of the background operation
     ***********************************************************************************************/
    protected void onPostExecute(Object result){
      try {
        dismissDialog(DIALOG_LOADING);
      }
      catch (Throwable t){
      }
      
      Activity thisActivity = getThisActivity();
      
      if (entries == null || entries.length <= 0 || entries[0] == null){
        thisActivity.runOnUiThread(new Runnable(){
          public void run(){
            WSAndroidPopup.showError(getThisActivity(),R.string.error_credentials_invalid);
            Settings.set("password",""); // so we don't keep autoLogin looping
            showLoginWindow(); // want to return back to the logon screen
            finish();
          }
          });
        return;
      }
      else {
        
        LinearLayout postsList = (LinearLayout)thisActivity.findViewById(R.id.posts_list);
        
        // so that we can refresh the list once a message is posted
        postsList.removeAllViews();
        
        int entryCount = entries.length;
        for (int i=0;i<entryCount;i++){
          //addPostEntry(entries[i]);
          MessageEntry entry = entries[i];
          if (entry != null){
            postsList.addView(entry.generateLayout(thisActivity));
          }
        }
        
        // scroll to the top
        ((ScrollView)thisActivity.findViewById(R.id.posts_list_scroll)).scrollTo(0,0);
      }

    }

  }

  
  /***********************************************************************************************
  Shows the about <code>Activity</code>
  ***********************************************************************************************/
  public void showLoginWindow(){
    Intent loginActivity = new Intent(getBaseContext(),LoginWindow.class);
    startActivity(loginActivity);
  }
  
  
  /***********************************************************************************************
  Shows the about <code>Activity</code>
  ***********************************************************************************************/
  public void showAbout(){
    Intent aboutActivity = new Intent(getBaseContext(),WSAboutScreen.class);
    startActivity(aboutActivity);
  }


  /***********************************************************************************************
  Shows the settings <code>Activity</code>
  ***********************************************************************************************/
  public void showSettings(){
    Intent settingsActivity = new Intent(getBaseContext(),WSSettingsChanger.class);
    startActivity(settingsActivity);
  }
  
}